package net.pingex.dcf.commands.audit.basic;

import net.pingex.dcf.commands.Context;
import net.pingex.dcf.commands.audit.AuditResult;
import net.pingex.dcf.commands.audit.IAuditComponentProvider;

/**
 * This component checks whether the command is invoked in the right scope.
 */
public class ScopeCheck implements IAuditComponentProvider
{
	@Override
	public AuditResult doAudit(Context context)
	{
		if(context.getCommand().getScope().test(context.getChannel()))
			return new AuditResult(AuditResult.ResultCode.PASS, null);
		else return new AuditResult(AuditResult.ResultCode.FAIL, "Cannot run this command outside of its intended scope. Valid scope is: " + context.getCommand().getScope() + ".");
	}

	@Override
	public String name()
	{
		return "Invocation scope check";
	}

	@Override
	public String description()
	{
		return "Checks whether the command is invoked in the right scope, ie. guild chat or PM.";
	}

	@Override
	public int priority()
	{
		return -2;
	}
}
